#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>
#include <linux/input.h>

#define TRUE  1
#define FALSE 0


#define MENU    139
#define OK      352
#define UP      102
#define DOWN    108
#define RIGHT   106
#define LEFT    105
#define RED     398

int                 key;
int                 RCtrl;     /* Remote Control file drescriptor */
int                 RCtrlCode; /* Remote Control KeyPressed */
struct input_event  RCevent;   /* Remote Control Event */
FILE               *outf;      /* kbd debug file */

int PutCtrlCode(num, keep)
int num;
int keep;
{
  int ret_val;
  
  ret_val = -1; /* No Event */
  
  RCevent.type = 1;
  RCevent.code = num;
  RCevent.value = 1;

  if (keep>0) {
     RCevent.value = 2;
  }
  
  write(key, &RCevent, sizeof(RCevent));    

  if (keep>0) {
     sleep(keep);
  }

  RCevent.type = 1;
  RCevent.code = num;
  RCevent.value = 0;

  write(key, &RCevent, sizeof(RCevent));    
	
  return ret_val;
}


int
main(argc, argv)
     int argc;
     char *argv[];
{
  struct input_id device_info;
  char *command;


  struct stat s;
  char tmp[128];
  int num,keep;

  keep=0;
  num=0;

  if (argc==1){


  printf("no Command passed, doing nothing\n");

  return 0;
  }

  if (argc==2){

  printf("Command: %s\n", argv[1]);
  num=atoi(argv[1]);
  }

  if (argc>2){

  printf("Command: %s keep: %s sec\n", argv[1], argv[2]);
  num=atoi(argv[1]);
  keep=atoi(argv[2]);
  }

  sprintf(tmp, "/dev/input/event1"); 

  if ((key=open(tmp, O_RDWR|O_NONBLOCK)) != -1){
     if (ioctl(key, EVIOCGNAME(128), tmp) < 0) perror("EVIOCGNAME failed");

     fcntl(key, F_SETFL, fcntl(key, F_GETFL) | O_EXCL | O_NONBLOCK);
      
     if(ioctl(key, EVIOCGID, &device_info)) perror("evdev ioctl");

    }

  PutCtrlCode(num,keep);

  close(key);
  
  return 0;
}
